//+------------------------------------------------------------------+
//|                                                     TestCall.mq4 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property strict
//---
#define MAX_SIZE 500000000
//+------------------------------------------------------------------+
//| base class                                                       |
//+------------------------------------------------------------------+
class C_001
  {
public:
   void      Fun(int n) { return; }
  };
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
int OnStart()
  {
   C_001 c001;
   uint tick_count,res;
//--- test
   tick_count=GetTickCount();
   for(int i=0;i<MAX_SIZE;i++)
      c001.Fun(i);
   res=GetTickCount()-tick_count;
   Print("Testing class method call ",res," ms.");
//---
   tick_count=GetTickCount();
   for(int i=0;i<MAX_SIZE;i++)
      TestCall(i);
   res=GetTickCount()-tick_count;
   Print("Testing function call ",res," ms.");
//--- returns test execution time, in milliseconds
   return((int)res);
  }
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
void TestCall(int n)
  {
  }
//+------------------------------------------------------------------+
