//+------------------------------------------------------------------+
//|                                                   TestMatrix.mq4 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property strict
//---
#define MAX_SIZE 168
//--- matrices
int m1[MAX_SIZE][MAX_SIZE],m2[MAX_SIZE][MAX_SIZE],mm[MAX_SIZE][MAX_SIZE];
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
int OnStart()
  {
   int  i,j,n=1;
   uint tick_count,res;
//--- test
   tick_count=GetTickCount();
   for(i=0;i<MAX_SIZE;i++)
      for(j=0;j<MAX_SIZE;j++)
        {
         m1[i][j]=n;
         m2[i][j]=n;
         n++;
        }
   for(i=0;i<MAX_SIZE;i++)
      TestMatrix();
   res=GetTickCount()-tick_count;
   Print("Testing multiplication of matrices ",res," ms.");
//--- returns test execution time, in milliseconds
   return((int)res);
  }
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
void TestMatrix()
  {
   int i,j,k,val;
//--- multiplication of matrices
   for(i=0;i<MAX_SIZE;i++)
     {
      for(j=0;j<MAX_SIZE;j++)
        {
         val=0;
         for(k=0;k<MAX_SIZE;k++)
           {
            val+=m1[i][k]*m2[k][j];
           }
         mm[i][j]=val;
        }
     }
  }
//+------------------------------------------------------------------+
