//+------------------------------------------------------------------+
//|                                                    TestSieve.mq4 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property strict
//---
#define MAX_SIZE 22500
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
int OnStart()
  {
   uint tick_count,res;
//--- test
   tick_count=GetTickCount();
   for(int i=0;i<MAX_SIZE;i++)
      TestSieve();
   res=GetTickCount()-tick_count;
   Print("Testing 'Sieve' algorithm ",res," ms.");
//--- returns test execution time, in milliseconds
   return((int)res);
  }
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
void TestSieve()
  {
   static int flags[MAX_SIZE];
   long       i,k;
   int        count=0;
//---
   for(i=1;i<MAX_SIZE;i++)
      flags[i]=1;
//---
   for(i=1;i<MAX_SIZE;i++)
     {
      if(flags[i])
        {
         for(k=i+i;k<MAX_SIZE;k+=i)
            flags[k]=0;
         count++;
        }
     }
  }
//+------------------------------------------------------------------+
