//+------------------------------------------------------------------+
//|                                                  TestStrPrep.mq4 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property strict
//---
#define MAX_SIZE 14000000
//---
string str="Print(\"Testing string parsing \",res,\" ms.\");";
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
int OnStart()
  {
   uint tick_count,res;
//--- test
   tick_count=GetTickCount();
   for(int i=0;i<MAX_SIZE;i++)
      TestStrPrep();
   res=GetTickCount()-tick_count;
   Print("Testing string parsing ",res," ms.");
//--- returns test execution time, in milliseconds
   return((int)res);
  }
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
void TestStrPrep()
  {
   int  i,c,nl,nw,nc;
   bool space;
//---
   space=true;
   nl=nw=nc=0;
//---
   nc+=StringLen(str);
   for(i=0; i<nc; i++)
     {
      c=StringGetCharacter(str,i);
      if(c=='\n')
         ++nl;
      if(c==' ' || c=='\r' || c=='\n' || c=='\t' || c=='\"')
         space=true;
      else
        {
         if(space)
           {
            space=false;
            ++nw;
           }
        }
     }
  }
//+------------------------------------------------------------------+
