//+------------------------------------------------------------------+
//|                                                TestAckermann.mq4 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property strict
//---
#define MAX_SIZE 12000
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
int OnStart()
  {
   uint res;
//--- test
   res=GetTickCount();
   for(int i=0;i<MAX_SIZE;i++)
      TestAckermann(3,5);
   res=GetTickCount()-res;
   Print("Testing Ackermann function ",res," ms.");
//--- returns test execution time, in milliseconds
   return((int)res);
  }
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
int TestAckermann(int m,int n)
  {
//---
   if(m==0) return(n+1);
   if(n==0) return(TestAckermann(m-1,1));
//---
   return(TestAckermann(m-1,TestAckermann(m,(n-1))));
  }
//+------------------------------------------------------------------+
